/*
 * AutomataProperties.java
 *
 * Created on 28. syyskuuta 2004, 18:46
 */

package org.rikastamo.automata;
/**
 *
 * @author  Raino
 * A frame for editing document properties
 */
import java.util.Vector;
import javax.swing.tree.*;

public class AutomataProperties extends javax.swing.JInternalFrame {
    AutomataCanvas cv;
    AutomataDocument dok;
    /** Creates new form AutomataProperties
     used for editing selected object's properties
     */
    public AutomataProperties() {
        initComponents();
    }
    public AutomataProperties(AutomataDocument doc){
         initComponents();
         cv = doc.canvas2;
         ReFill();    
        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener(){
        public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
            // Get all nodes whose selection status has changed
            TreePath[] paths = evt.getPaths();
            // Iterate through all affected nodes
            for (int i=0; i<paths.length; i++) {
                if (evt.isAddedPath(i)) {
                    // This node has been selected
                    //i on syvyys!! kusee
                    AutomataElement ae = (AutomataElement)cv.elements.elementAt(i+1);
                    if(ae!= null)
                        ae.selected = true;
                } else {
                    // This node has been deselected
                    AutomataElement ae = (AutomataElement)cv.elements.elementAt(i+1);
                    if(ae!= null)
                        ae.selected = false;
                }
            }
            ReFill();
        }
    });
   }
     /**
 * Set the document that is reported
 */   
    public void setDocument(AutomataDocument doc){
        cv = doc.canvas2;
        dok = doc;
        ReFill();
    }
     /**
    * Selects object - called from gui when select tool used
    */    
public void selectObject(int a){
    //show selected objects properties in the element panel
   //call the selected object to change selected status
}
     /**
 * Refill all the tables with new data
 */   
    public void ReFill(){   
        int documentarea = 0;
        //load tree
         DefaultMutableTreeNode root=new DefaultMutableTreeNode("Layers");
         DefaultMutableTreeNode element;        
         //for(int x = 1; x <= cv.elements.size()-1; x++){
         for(int x = cv.elements.size()-1; x >= 1; x--){
               AutomataElement ae = (AutomataElement)cv.elements.elementAt(x);
               element = new DefaultMutableTreeNode(x + ": " + ae.name);
               root.add(element);
               documentarea = documentarea + ae.width*ae.height;
               /* nosta taulukkoon valitun elementin tiedot
               if(ae.selected)
                   jTable1.dataModel.setValueAt(ae.name, 2, 2);
               **/ 
        }
        DefaultTreeModel treeModel = new DefaultTreeModel(root);
        jTree2.setModel(treeModel); 
        //load element variables
            
        //load document properties
        //setArea(documentarea)
        //load layer/object properties
        //selectObject(1);
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jScrollPane2 = new javax.swing.JScrollPane();
        jLabel2 = new javax.swing.JLabel();
        jTree1 = new javax.swing.JTree();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jTable1 = new javax.swing.JTable();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTree2 = new javax.swing.JTree();
        jPanel3 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jTable2 = new javax.swing.JTable();

        jLabel2.setText("jLabel2");
        jTree1.setBackground(new java.awt.Color(204, 204, 204));
        jTree1.setName("layertree");
        jTree1.setRootVisible(false);

        setBorder(null);
        setTitle("Properties");
        setToolTipText("Object properties");
        jTabbedPane1.setTabLayoutPolicy(javax.swing.JTabbedPane.SCROLL_TAB_LAYOUT);
        jTabbedPane1.setName("nam");
        jPanel2.setLayout(new java.awt.GridLayout(2, 0));

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"name", "element 1"},
                {"type", "menu"},
                {"bgcolor", "white (color 1)"},
                {"text size", "12"},
                {"text color", "black (color 2)"},
                {"height", "200"},
                {"width", "300"}
            },
            new String [] {
                "name", "value"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Object.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                false, true
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jPanel2.add(jTable1);

        jTabbedPane1.addTab("Element", jPanel2);

        jPanel5.setLayout(new java.awt.BorderLayout());

        jScrollPane1.setToolTipText("select");
        jScrollPane1.setViewportView(jTree2);

        jPanel5.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel3.setPreferredSize(new java.awt.Dimension(41, 33));
        jButton1.setText("up");
        jPanel3.add(jButton1);

        jButton2.setText("down");
        jPanel3.add(jButton2);

        jButton3.setText("Remove");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RemoveSelectedElement(evt);
            }
        });

        jPanel3.add(jButton3);

        jPanel5.add(jPanel3, java.awt.BorderLayout.SOUTH);

        jTabbedPane1.addTab("Layer", jPanel5);

        jPanel4.setLayout(new java.awt.GridLayout(1, 0));

        jTable2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"covered area", "0"},
                {"color 1 area", "0"},
                {"color 2 area", "0"},
                {"color 3 area", "0"},
                {"snap to grid", null}
            },
            new String [] {
                "item", "Title 2"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable2.setShowHorizontalLines(false);
        jTable2.setShowVerticalLines(false);
        jTable2.setSurrendersFocusOnKeystroke(true);
        jPanel4.add(jTable2);

        jTabbedPane1.addTab("Document", jPanel4);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void RemoveSelectedElement(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RemoveSelectedElement
            ReFill();
    }//GEN-LAST:event_RemoveSelectedElement
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JTable jTable2;
    private javax.swing.JTree jTree1;
    private javax.swing.JTree jTree2;
    // End of variables declaration//GEN-END:variables
    
}
